/*
 * Copyright 2008 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 */


/*
 * example.cpp
 *
 *  Created on: 2010/11/18
 *      Author: HARK Development Team
 */

/*
 * 次元保証ライブラリ使用サンプル
 */

#include <iostream>
#include <cmath>

using namespace std;

int main()
{
  double len1 = 20; // 20 meter
  double len2 = 3; // 3 meter
  double s;
  double l;
  double ang;

  s = len1 * len2; // OK
  // l = len1 * len2; // NO ERROR, but this operation should be invalid.
  cout << "area s = " <<
      s << " m^2 = " <<
      s * 1e6 << " mm^2" << endl;

  // s = len1 + len2; // NO ERROR, but this operation should be invalid.
  l = len1 + len2;
  cout << "length l = " <<
      l << " m = " <<
      l * 1e3 << " mm" << endl;

  // a = len1; // NO ERROR, but this operation should be invalid.
  ang = len1 / len2; // OK
  cout << "angle ang = " <<
      ang * 180 / M_PI << " deg = " <<
      ang << " rad" << endl;
  return 0;
}
